/*-----copyright-----
 *     amy-studio - make development easier 
 *     web        : http://www.amy-studio.com
 *     taobao     : http://amy-studio.taobao.com
 *     qq(e_mail) : amystudio@qq.com
 *-----file info-----
 *     name       : div_50M.v
 *     author     : Yuphone Chang
 *     description: frequency divider; coefficient is 50M; 50% duty cycle
 *----- version -----
 *     created    : 7.20, 2010
 *     version    : 1.0
 *     description: original version
 *
 *     modified   : 
 *     version    : 
 *     description: 
 *-------------------
 */

module div_50M(
  input      clk,
  input      rst_n,
  output reg o_clk
);

reg [25:0] cnt;

always @ (posedge clk, negedge rst_n)
  if (!rst_n) 
    cnt <= 0;
  else
    if (cnt == 49_999_999)
      cnt <= 0;
    else
    cnt <= cnt + 1'b1;
    
always @ (posedge clk, negedge rst_n)
  if (!rst_n) 
    o_clk <= 0;
  else
    if (cnt <= 24_999_999)              // 24_999_999 = 50M/2 - 1
      o_clk <= 0;
    else
      o_clk <= 1;                               

endmodule
